<?
	/**
	 * Name: Kilho's PHP Diagnosis
	 * Author: Kilho Oh (prince@kilho.net) 
	 * Author URI: http://kilho.net/
	 */

	class TDiagnosis
	{
		public $dir;

		public function __construct()
		{
			$this->dir = $_SERVER['DOCUMENT_ROOT'].'/';
		}

		private function SeekFile($dir, &$files)
		{
			$hnd = opendir($dir);
			while (false !== ($entry = readdir($hnd))) 
			{
				if(in_array($entry, array('.', '..'))) continue;

				if(is_dir($dir.$entry) && !in_array($entry, array('.', '..')))
				{
					$this->SeekFile($dir.$entry.'/', $files);
				}else{
					if(!in_array(substr($entry, strrpos($entry, '.')+1), array('php', 'inc', 'html', 'htm', 'php3'))) continue;

					$file = $dir.$entry;
					if(!in_array($file, $files)) $files[] = $file;
				}
			}
			closedir($hnd);
		}

		private function Diagnosis($files)
		{
			$suspicion = array();
			$loop = 0;
			do {
				$file = $files[$loop];
				$loop++;
				
				if($file == $_SERVER['SCRIPT_FILENAME']) continue;

				$data = file_get_contents($file);
				$data = preg_replace('/\/\*(.*?)\*\//is', '', $data);
				$data = preg_replace('/\/\/*(.*)\n/', '', $data);

				if(preg_match('/(^|\s|\?php3|[?])(eval|system|exec)\s*\(/i', $data))
					$suspicion[] = $file; 
			} while ($loop < count($files));

			return $suspicion;
		}

		public function Run()
		{
			$files = array();
			$this->SeekFile($_SERVER['DOCUMENT_ROOT'].'/', $files);
			return $this->Diagnosis($files);
		}
	}

	/**
	 * Main
	 */

	$diagnosis = new TDiagnosis;

	$result['host'] = $_SERVER['HTTP_HOST'];
	$result['suspicion'] = $diagnosis->run();

	echo json_encode($result);
?>